var sConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
var fileContent;                    // holds the content of the message
var fileContentOriginal;            // holds the content of the original message
var DAorigFileName = '';            //
var DAFileName = '';            //
var DAtimeoutVal = 200;
var doDebugging = true;
var DApreselectedURI = '';
var DAoldMsgKey;
var DAmsgPaneCollapsed;
var DAinitialCopyDone ;
var DAinDeleteAttachmentTrans ;
var DAstepsCompleted ;

var DAfolderListener = {
  OnItemAdded: function(parentItem, item) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIA item>' + item + '<, parent>' + parentItem  + '<');
    },

  OnItemRemoved: function(parentItem, item) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIR item>' + item + '<, parent>' + parentItem  + '<');
    },

  OnItemPropertyChanged: function(item, property, oldValue, newValue) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIPC item>' + item + '<, property>' + property + '< oldvalue>' + oldValue + '< newValue>' + newValue + '<');
    },

  OnItemIntPropertyChanged: function(item, property, oldValue, newValue) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIIPC item>' + item + '<, property>' + property + '< oldvalue>' + oldValue + '< newValue>' + newValue + '<');
    },

  OnItemBoolPropertyChanged: function(item, property, oldValue, newValue) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIBPC item>' + item + '<, property>' + property + '< oldvalue>' + oldValue + '< newValue>' + newValue + '<');

    },
  OnItemUnicharPropertyChanged: function(item, property, oldValue, newValue){
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIUPC item>' + item + '<, property>' + property + '< oldvalue>' + oldValue + '< newValue>' + newValue + '<');

    },
  OnItemPropertyFlagChanged: function(item, property, oldFlag, newFlag) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIPFC item>' + item + '<, property>' + property + '< oldflag>' + oldFlag + '< newFlag>' + newFlag + '<');
    },

  OnItemEvent: function(folder, event) {
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: LIE folder>' + folder + '<, event>' + event + '<');
    var eventType = event.toString();
    if (eventType == 'CompactCompleted') {
        if (DAstepsCompleted == 3.5) { 
            if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Listener Triggered, proceeding to step 4');
            DAStep4(); 
        }
    }
    if (eventType == 'DeleteOrMoveMsgCompleted') {
        if (DAstepsCompleted == 3) { 
            if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Listener Triggered, proceeding to step 3a');
            DAStep3a(); 
        }
        if (DAstepsCompleted == 2) { 
            if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Listener Triggered, proceeding to step 3');
            DAStep3(); 
        }
    }
  }  
}

function setStatus(newStatus) {	document.getElementById("statusText").setAttribute("label", newStatus);}

function deleteAttachment() {
    DAinitialCopyDone = false;
    var dbv = GetDBView()
    if (!dbv) return;           // this checks that user has selected a message
    
    // should make sure we only have one message selected
    try{
        dbv.selectMsgByKey(dbv.keyForFirstSelectedMessage);
    } catch(e) {
        if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 1 - could not select only one message >" + e); 
        return;
    }
    DAoldMsgKey = dbv.keyForFirstSelectedMessage;

    // should check to see if the selected message has attachments
    if (dbv.db.HasAttachments(dbv.keyForFirstSelectedMessage) == false) { alert('Delete Attachment - No attachment to delete'); return; }

    // a pref is available for slowing down operation should the user need to ( slower machines )
    try {
        var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
        DAtimeoutVal = pref.getIntPref("delattach.timeoutValue");
        doDebugging = pref.getBoolPref("delattach.debug");
    } catch(e) {
        //sConsoleService.logStringMessage("DeleteAttach - Step 1 - timeoutValue pref was missing, setting to true >" + e); 
        pref.setIntPref("delattach.timeoutValue", DAtimeoutVal);
        pref.setBoolPref("delattach.debug", doDebugging);
    }
    DAStep1();
}

function DAStep1() {
    // step 1 - make a new folder

    // lets just make sure the folder is not there already, delete if it is
    DAstepsCompleted = 0;
    DAStep9("0")

    setStatus('Step 1 - Making a temporary folder');
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 1 - Found a viable message, key is " + DAoldMsgKey);
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 1 - Making a temporary folder");
    DApreselectedURI = "mailbox://nobody@Local%20Folders/Trash"
    var selectedFolderResource = RDF.GetResource(DApreselectedURI);
    var compositeDataSource = GetCompositeDataSource("NewFolder");            
    var folderArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
    var nameArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);        
    folderArray.AppendElement(selectedFolderResource);
    nameArray.AppendElement(RDF.GetLiteral("delAtttemP"));
    DoRDFCommand(compositeDataSource, "http://home.netscape.com/NC-rdf#NewFolder", folderArray, nameArray);
    DAstepsCompleted = 1;
    if (DAstepsCompleted != 1) { sConsoleService.logStringMessage('DeleteAttach: Step 1 failure- Could not create a temp folder'); return; }
    DAStep2()
}

function DAStep2() {
    // step 2 - copy the selected message there
    setStatus('Step 2 - Copying the selected message to temporary folder')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 2 - Copying the selected message to temporary folder")
    //set up the folder listener to trigger the staep after this one on message move or copy completed
    try {
        var nsIFolderListener = Components.interfaces.nsIFolderListener;
        var notifyFlags = nsIFolderListener.all;
        mailSession.AddFolderListener(DAfolderListener, notifyFlags);
    } catch (ex) {   sConsoleService.logStringMessage('DeleteAttach: Catch Error - adding folder listener - '+e);return;    }

    try {
        var dbv = GetDBView();
        var destUri = DApreselectedURI + "/delAtttemP"
        var destResource = RDF.GetResource(destUri);
        var destMsgFolder = destResource.QueryInterface(Components.interfaces.nsIMsgFolder);
        DAFileName = destMsgFolder.path.nativePath;
        DAstepsCompleted = 2;
        dbv.doCommandWithFolder(nsMsgViewCommandType.copyMessages, destMsgFolder);
    } catch(e) { 
        mailSession.RemoveFolderListener(DAfolderListener);
        if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Step 2 Failure - '+e); 
    }
}


function DAStep3() {
    // this is triggered by the folder listener
    mailSession.RemoveFolderListener(DAfolderListener);
    setStatus('Step 3 - Deleting the original message')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 3 - Going to delete the original message DAoldmsgKey-" + DAoldMsgKey);
    //set up the folder listener to trigger the step after this one on message move or copy completed
    try {
        var nsIFolderListener = Components.interfaces.nsIFolderListener;
        var notifyFlags = nsIFolderListener.all;
        mailSession.AddFolderListener(DAfolderListener, notifyFlags);
    } catch (ex) {   sConsoleService.logStringMessage('DeleteAttach: Caught Error - adding folder listener - '+e);return;    }
    try {
        var dbv = GetDBView();    
        dbv.selectMsgByKey(DAoldMsgKey); 
        //dbv.doCommand(nsMsgViewCommandType.deleteNoTrash);// this sends the message to heaven, bypassing trash
        DAstepsCompleted = 3
        dbv.doCommand(nsMsgViewCommandType.deleteMsg);      // this sends the message to the trash
    } catch(e) {
         sConsoleService.logStringMessage('DeleteAttach: Step 3 Failure - Could not delete original message'+e); 
    }
}



function DAStep3a() {
    // this is triggered by the folder listener
    // step 3a - now we going to compact the original folder 
    mailSession.RemoveFolderListener(DAfolderListener);
    setStatus('Step 3a - Compacting Original Folder')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 3a - Compacting Original Folder");
    //set up the folder listener to trigger the step after this one on CompactCompleted
    try {
        var nsIFolderListener = Components.interfaces.nsIFolderListener;
        var notifyFlags = nsIFolderListener.all;
        mailSession.AddFolderListener(DAfolderListener, notifyFlags);
    } catch (ex) {   sConsoleService.logStringMessage('DeleteAttach: Caught Error - adding folder listener - '+e);return;    }
    DAstepsCompleted = 3.5
    MsgCompactFolder(false);
}


function DAStep4() {
    mailSession.RemoveFolderListener(DAfolderListener);
    // step 4 - now we have to select the first message in the temp folder 
    setStatus('Step 4 - Closing Original Folder')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 4 - Closing Original Folder");
    try{    
        DAforceDBclosed();
    } catch(e) {
        sConsoleService.logStringMessage('DeleteAttach: Step 4 Caught Error - Could not close Original Folder'+e);
        return; 
    }
    DAStep5();
}

function DAStep5() {
    // step 5 - open the temp folder's file and hold contents in FileContent var
    setStatus("Step 5 - Reading in the temporary folder's file")
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 5 - Reading in the temporary folder's file")
    try {
        // gotta get the filename of the temp folder's file
        // this should be the filename of the trash/delAtttemP folder
        //now open the file into a var
        var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        sfile.initWithPath(DAFileName);
        var fileInputStream =  Components.classes["@mozilla.org/network/file-input-stream;1"].createInstance(Components.interfaces.nsIFileInputStream);
        fileInputStream.init( sfile, 0x01, 0444, null );
        var fileScriptableIO = Components.classes["@mozilla.org/scriptableinputstream;1"].createInstance(Components.interfaces.nsIScriptableInputStream);
        fileScriptableIO.init(fileInputStream);
        fileContent = ''
        fileContent = fileScriptableIO.read( sfile.fileSize );
        fileScriptableIO.close();
        fileInputStream.close();
        DAstepsCompleted = 5;
        if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 5 - Read in the temporary folder's file successfully, length is " + sfile.fileSize )
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step 5 Caught Error - '+e); }

    if (DAstepsCompleted != 5) {sConsoleService.logStringMessage("DeleteAttach: Step 5 Failure - Could not open the temp folder's file"); return; }
    DAStep6();
}

function DAStep6() {
    // step 6 - now find the attachment and delete it
    setStatus('Step 6 - Stripping the attachment(s)')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 6 - Stripping the attachment(s)");
    try {
        var holder = '';
        // this is where we parse the message and strip out the attachment(s)
        holder = stripAttachments(fileContent);
        DAstepsCompleted = 6;
        // ok now we should have a the message without any attachments
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step 6 Caught Error - '+e); }

    if (DAstepsCompleted != 6) {sConsoleService.logStringMessage('DeleteAttach: Step 6 Failure - Could not strip attachments from the message'); return; }
    DAStep7();
}

function DAStep7() {
    // step 7 - lets now write the modified message to the end of the original folder    
    setStatus("Step 7 - Appending the message onto the end of the original folder ")
    // the following is a trial of the append routine
    try {
        if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 7 - Appending the message onto the end of the original folder's file");
        var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        sfile.initWithPath(DAorigFileName);
        if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Step 7- original folder filesize is> ' + sfile.fileSize);
        var stream = Components.classes['@mozilla.org/network/file-output-stream;1'].createInstance(Components.interfaces.nsIFileOutputStream);
        stream.init(sfile, 0x12, 0x200, false); // open as "append"
        stream.write(holder, holder.length);
        stream.close();
        var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        sfile.initWithPath(DAorigFileName);
        if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Step 7- original folder filesize is now> ' + sfile.fileSize);
        DAstepsCompleted = 7;
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step 7 - Caught Error - '+e); }

    if (DAstepsCompleted != 7) {sConsoleService.logStringMessage('DeleteAttach: Step 7 Failure- Could not append the message onto the end of the original folder'); return; }
    DAStep8();
}

function DAStep8() {
    setStatus('Step 8 - Attempting to delete original folder msf file')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 8 - Attempting to delete original folder msf file >" + DAorigFileName + ".msf<");
    try {
        var sfile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
        sfile.initWithPath(DAorigFileName + ".msf");
        if (sfile.exists()) sfile.remove(true);
        DAstepsCompleted = 8;
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step 8 Caught Error - '+e); }

    if (DAstepsCompleted != 8) {sConsoleService.logStringMessage('DeleteAttach: Step 8 Failure - Could not copy new message back to original folder'); return; }
    DAStep9();
}

function DAStep9 () {
     var dbv = GetDBView()
    // step 9 - now lets delete the temp folder
    if (DAstepsCompleted == 0) {
        setStatus('Step 0 - Making sure the temporary folder does not exist')
        if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 0 - Making sure the temporary folder does not exist");
    } else {
        setStatus('Step 9 - Really deleting temporary folder ')
        if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 9 - Really Deleting the temporary folder");
    }
    try {
        var tempFolderResource = RDF.GetResource("mailbox://nobody@Local%20Folders/Trash/delAtttemP");
        var parFolderResource = RDF.GetResource("mailbox://nobody@Local%20Folders/Trash");
        var parentArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);
        var deletedArray = Components.classes["@mozilla.org/supports-array;1"].createInstance(Components.interfaces.nsISupportsArray);        
        parentArray.AppendElement(parFolderResource);
        deletedArray.AppendElement(tempFolderResource);
        DoRDFCommand(GetFolderDatasource(), "http://home.netscape.com/NC-rdf#ReallyDelete", parentArray, deletedArray);    
        if (DAstepsCompleted == 0) { return; }
        DAstepsCompleted = 9;
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step ' + stepNum + ' Caught Error - '+e); }

    if (DAstepsCompleted != 9) {sConsoleService.logStringMessage('DeleteAttach: Step 9 Failure- Could not delete the temp folder'); return; }
    DA_ReOpenDB() ;
}

function DA_ReOpenDB() {
    setStatus('Step 10 - Re-opening Database ')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 10 - Re-opening Database");
    var folderTree = GetFolderTree();
    var folderSelection = folderTree.view.selection;
    var startIndex = {};
    var endIndex = {};
    folderSelection.getRangeAt(0, startIndex, endIndex);
    var folderResource = GetFolderResource(folderTree, startIndex.value);
    var msgFolder = folderResource.QueryInterface(Components.interfaces.nsIMsgFolder);
    var sortType = 0;
    var sortOrder = 0;
    var viewFlags = 0;
    var viewType = 0;
    var msgDatabase = msgFolder.getMsgDatabase(msgWindow);
    if (msgDatabase)
    {
      var dbFolderInfo = msgDatabase.dBFolderInfo;
      sortType = dbFolderInfo.sortType;
      sortOrder = dbFolderInfo.sortOrder;
      viewFlags = dbFolderInfo.viewFlags;
      viewType = dbFolderInfo.viewType;
      msgDatabase = null;
      dbFolderInfo = null;
    }
    ChangeFolderByURI(folderResource.Value, viewType, viewFlags, sortType, sortOrder);
    setStatus('Finished deleting attachment')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Finished deleting attachment");
	window.setTimeout("setStatus('')", "3000");
}

function DAStep11() {

    // step 11 cannot be enabled until we figure out how to wait until the msf file is rebuilt
    //  we cannot set a timer because of the possibility that the msf rebuild takes an awfully long time

    // step 11 - now lets reload the message to update the message pane and compact the original folder to be nice.
    setStatus('Step 11 - Reloading the message and compacting original folder')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Step 11 - Reloading the message and compacting original folder");
    try {
        MsgReload();
        MsgCompactFolder(false);
    } catch(e) { sConsoleService.logStringMessage('DeleteAttach: Step 11 Caught Error - '+e); }
    setTimeout(goDoCommand,DAtimeoutVal,'cmd_previousUnreadMsg');               // selecting any message in the original folder 
    setStatus('Finished deleting attachment')
    if (doDebugging) sConsoleService.logStringMessage("DeleteAttach: Finished deleting attachment");
	window.setTimeout("setStatus('')", "3000");
}


function stripAttachments(fileContent) {
    // this function splits up a message into lines ( lines are array items of contentArr), strips out 
    //  only DATA of an attachment, it leaves any boundary indicators alone
    //  this is necessary because of possible nested 'parts' 
    //  it also does not touch multipart part indicators, rfc822 part indicators or text/ indicators

    // taking out the pref for enabling changing subject, look below for reason
    var pref = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
    var chgSubj = false;
    try {
        chgSubj = pref.getBoolPref("delattach.changesubject");
    } catch(e) { }

    // this is an array of types will will not study/modify
    var arrOfTypes = ["multipart/", "text/plain", "text/html", "message/rfc822"]

    // this is an indicator that we found a Content-Type that is in the above array
    var modifyThisType = true;

    // this is an indicator that we have not found the first Content-Type
    var foundFirstCT = false;
    
    // this var is going to contain what WILL be the new message source
    holder = '';

    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: StripFunction - incoming file first 3 chars are ' + fileContent.charCodeAt(0) + ' ' + fileContent.charCodeAt(1) + ' ' + fileContent.charCodeAt(2) + '< '); 
    var fcl = fileContent.length;
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: StripFunction - incoming file last 5 chars are ' + fileContent.charCodeAt(fcl-5) + ' ' + fileContent.charCodeAt(fcl-4) + ' ' + fileContent.charCodeAt(fcl-3) + ' ' + fileContent.charCodeAt(fcl-2) + ' ' + fileContent.charCodeAt(fcl-1) + '< '); 

    var contentArr = fileContent.split('\n');
    var tot = contentArr.length  ;
    foundFirstCT = false;
    for (i=0; i < contentArr.length ; i++ ) {
        if (contentArr[i].toLowerCase().indexOf('content-type: ') > -1) {
            //sConsoleService.logStringMessage('found Content contentArr>' +  contentArr[i] +'<')
            modifyThisType = true;
            for (j= 0; j < arrOfTypes.length; j++) {
                //sConsoleService.logStringMessage('arrof>' +  'content-type: ' + arrOfTypes[j]  +'<')
                if (contentArr[i].toLowerCase().indexOf('content-type: ' + arrOfTypes[j]) > -1 ) { 
                    //sConsoleService.logStringMessage('breaking out contentArr>' +  contentArr[i] +'<')
                    foundFirstCT = true;
                    modifyThisType = false;
                    break; 
                }
            }
            if (modifyThisType) {
                //sConsoleService.logStringMessage('found content type contentArr>' +  contentArr[i] +'<')
                // insert the line that contains the content-type
                holder += contentArr[i]  + '\n';
                i = i + 1
                // start looking for a blank line, adding lines as we go
                while ( contentArr[i].length > 2) {
                    if (contentArr[i].indexOf('filename=') > -1) {
                        var fnpos = contentArr[i].indexOf('filename=')
                        var oldfn1 = contentArr[i].substring(0,fnpos + 10);
                        var oldfn2 = contentArr[i].substr(fnpos + 10);
                        contentArr[i] = oldfn1 + '*erased* ' + oldfn2
                    }
                    holder += contentArr[i]  + '\n';
                    //sConsoleService.logStringMessage('adding contentArr>' +  contentArr[i] +'<')
                    i = i + 1
                }
                // found a blank line, start looking for start of attachment data, NOT adding (blank) lines
                while ( contentArr[i].length < 3 ) {
                    //sConsoleService.logStringMessage('chewing up blank contentArr>' +  contentArr[i] +'<')
                    // chew through the attachment data
                    i = i + 1
                }        
                // found attachment data, look for the -- end of attachment indicator 
                while ( 0 == 0 ) {
                    if (contentArr[i].substring(0,2) == "--") {
                        if (contentArr[i].length > 5) {
                            // this makes sure we are not going to hit on a non 'end of attachment indicator'
                            break;
                        }
                    }
                    //sConsoleService.logStringMessage('chewing up attachment data contentArr>' +  contentArr[i] +'<')
                    // chew through the attachment data
                    i = i + 1
               }
                // add proper crlf pair at the end
                holder += '\r' + '\n';
            }
        }
        // this next if block is here for anyone who wants to know
        // we *can* change the subject, but the summary file ( .msf file ) is NOT updated, therefore the new subject will only appear 
        //  in the message header, NOT on the thread pane
        if (contentArr[i].indexOf('Subject:') > -1 && !foundFirstCT && chgSubj) {
            if (window.confirm('Do you want to change the Subject ? ')) {
                // stuff here to change the subject
                var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
                oldSubj = contentArr[i].substr(9);
                newSubject = {value:oldSubj};
                var rv = promptService.prompt(window, "Delete Attach","What do you want the new subject to be", newSubject, null, {value:0});
                if (rv) {
                    contentArr[i] = 'Subject: ' + newSubject.value; // + whatever they typed in
                }
            }
        }
        //sConsoleService.logStringMessage('adding regular contentarr>' +  contentArr[i] +'<')
        // this adds the line into the holder 
        holder += contentArr[i]  + '\n';
   }
   // strip off last redundant \n
    holder = holder.substring(0,holder.length -1);
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: StripFunction - outgoing file first 3 chars are ' + holder.charCodeAt(0) + ' ' + holder.charCodeAt(1) + ' ' + holder.charCodeAt(2) + '< '); 
    var fcl = holder.length;
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: StripFunction - outgoing file last 5 chars are ' + holder.charCodeAt(fcl-5) + ' ' + holder.charCodeAt(fcl-4) + ' ' + holder.charCodeAt(fcl-3) + ' ' + holder.charCodeAt(fcl-2) + ' ' + holder.charCodeAt(fcl-1) + '< '); 
    return holder;
}

function DAforceDBclosed() {
    // we are going to force the db closed so that we can delete the msf file later
    var dbv = GetDBView()
    DAorigFileName = dbv.msgFolder.path.nativePath 
    setStatus('Forcing DB closed')
    if (doDebugging) sConsoleService.logStringMessage('DeleteAttach: Step 4.5 - Forcing DB closed, the original folderpath is >' + DAorigFileName + '<') 
    dbv.db.ForceClosed()
} 

function setDAmenuitem() {} 
